--- i18n (Kopie).c	2006-04-15 16:13:45.000000000 +0200
+++ i18n.c	2006-04-19 20:44:04.000000000 +0200
@@ -1364,7 +1364,7 @@
     "Nahrávání zaène za %ld minut - pøesto vypnout?",
   },
   { "Press any key to cancel shutdown",
-    "Taste drücken, um Shutdown abzubrechen",
+    "Taste drücken, um Abschaltung abzubrechen",
     "Pritisni katerikoli gumb za preklic izklopa",
     "Un tasto per annullare lo spegnimento",
     "Druk een toets om shutdown af te breken",
@@ -1761,7 +1761,7 @@
     "Inversion",
   },
   { "Bandwidth",
-    "Bandwidth",
+    "Bandbreite",
     "Pasovna ¹irina",
     "Bandwidth",
     "Bandwidth",
@@ -1893,7 +1893,7 @@
     "Guard",
   },
   { "Hierarchy",
-    "Hierarchy",
+    "Hierarchie",
     "Hierarhija",
     "Hierarchy",
     "Hierarchy",
@@ -2467,7 +2467,7 @@
     "Editaèní proces je ji¾ aktivní!",
   },
   { "Can't shutdown - option '-s' not given!",
-    "Shutdown unmöglich - Option '-s' fehlt!",
+    "Abschaltung unmöglich - Option '-s' fehlt!",
     "Zaustavitev ni izvedljiva - opcija '-s' ni podana!",
     "Impossibile spegnere - parametro '-s' non passato!",
     "Shutdown onmogelijk - Optie '-s' ontbreekt!",
@@ -2599,7 +2599,7 @@
     "Restartuje se CAM...",
   },
   { "Can't reset CAM!",
-    "CAM-Reset fehlgeschlagen!",
+    "Zurücksetzen des CAM fehlgeschlagen!",
     "Ne morem resetirati CAM-a",
     "Impossibile reimpostare il modulo CAM!",
     "Kan CAM niet herstarten!",
@@ -3371,7 +3371,7 @@
     "Seznam nahrávek",
   },
   { "Setup.EPG$EPG scan timeout (h)",
-    "Zeit bis EPG Scan (h)",
+    "Zeit bis EPG Abfrage (h)",
     "Èas do EPG pregleda (h)",
     "Timeout scansione aggiornamento EPG (ore)",
     "EPG-scan Timeout (h)",
@@ -3965,7 +3965,7 @@
     "CICAM DVB",
   },
   { "Setup.Recording$Margin at start (min)",
-    "Zeitpuffer bei Anfang (min)",
+    "Zeitspanne vor Anfang (min)",
     "Premik zaèetka snemanja (min)",
     "Margine iniziale (min)",
     "Tijd marge begin (min)",
@@ -3987,7 +3987,7 @@
     "Nahrávat pøed zaèátkem (min)",
   },
   { "Setup.Recording$Margin at stop (min)",
-    "Zeitpuffer bei Ende (min)",
+    "Zeitspanne nach Ende (min)",
     "Zamik konca snemanja (min)",
     "Margine finale (min)",
     "Tijd marge eind (min)",
@@ -4163,7 +4163,7 @@
     "Pou¾ívat VPS",
   },
   { "Setup.Recording$VPS margin (s)",
-    "Zeitpuffer bei VPS (s)",
+    "Zeitspanne bei VPS (s)",
     "Èasovna rezerva pri VPS (s)",
     "Margine VPS",
     "Marge VPS (s)",
@@ -4295,7 +4295,7 @@
     "Dìlit editované soubory",
   },
   { "Setup.Replay$Multi speed mode",
-    "MultiSpeed Modus",
+    "Mehrere Geschwindigkeiten",
     "Re¾im z veè hitrostmi",
     "Modalita' multispeed",
     "Multi-speed mode",
@@ -4405,7 +4405,7 @@
     "Èasový limit neaktivnosti (min)",
   },
   { "Setup.Miscellaneous$SVDRP timeout (s)",
-    "SVDRP Timeout (s)",
+    "Maximale SVDRP Zeit (s)",
     "SVDRP èas neaktivnosti (s)",
     "Timeout SVDRP (s)",
     "SVDRP Timeout (s)",
@@ -4427,7 +4427,7 @@
     "Èasový limit SVDRP (s)",
   },
   { "Setup.Miscellaneous$Zap timeout (s)",
-    "Zap Timeout (s)",
+    "Zap mindest Zeit (s)",
     "Èas ugla¹evanja (s)",
     "Timeout Zapping",
     "Zap timeout (s)",
@@ -4607,7 +4607,7 @@
   },
   // Learning keys:
   { "Learning Remote Control Keys",
-    "Fernbedienungs-Codes lernen",
+    "Belegung der Fernbedienung lernen",
     "Uèenje kod upravljalca",
     "Apprendimento tasti unita` remota",
     "Leren toetsen afstandsbediening",
@@ -4629,7 +4629,7 @@
     "Uèení kódù dálkového ovládání",
   },
   { "Phase 1: Detecting RC code type",
-    "Phase 1: FB Code feststellen",
+    "Phase 1: FB Typ feststellen",
     "Faza 1: Sprejemanje IR kode",
     "Fase 1: tipo ricevitore RC",
     "Fase 1: detecteren type afstandsbediening",
@@ -4673,7 +4673,7 @@
     "Stisknìte libovolnou klávesu ovládání",
   },
   { "RC code detected!",
-    "FB Code erkannt!",
+    "FB Typ erkannt!",
     "IR koda sprejeta!",
     "Codice RC rilevato!",
     "Afstandsbediening code herkend!",
@@ -4717,7 +4717,7 @@
     "Nemaèkejte ¾ádné klávesy...",
   },
   { "Phase 2: Learning specific key codes",
-    "Phase 2: Einzelne Tastencodes lernen",
+    "Phase 2: Einzelne Tasten lernen",
     "Faza 2: Uèenje posebnih kod",
     "Fase 2: Codici specifici dei tasti",
     "Fase 2: Leren specifieke toets-codes",
@@ -4871,7 +4871,7 @@
     "(stisknìte 'Menu' pro pøeskoèení definice klávesy)",
   },
   { "Phase 3: Saving key codes",
-    "Phase 3: Codes abspeichern",
+    "Phase 3: Tastenbelegung abspeichern",
     "Faza 3: Shranjevanje kod tipk",
     "Fase 3: Salvataggio codici tasti",
     "Fase 3: Opslaan toets codes",
@@ -5995,7 +5995,7 @@
     "Pøeru¹uje se bì¾ící program ...",
   },
   { "Starting EPG scan",
-    "Beginne mit EPG-Scan",
+    "Beginne mit EPG Abfrage",
     "Prièenjam EPG-scan",
     "",// TODO
     "Bezig met starten EPG scan",
@@ -6017,7 +6017,7 @@
     "Zaèíná prohledávání EPG",
   },
   { "This plugin has no setup parameters!",
-    "Dieses Plugin hat keine Setup-Parameter!",
+    "Dieses Plugin hat keine einstellbaren Parameter!",
     "Ta plugin nima nastavitvenih parametrov!",
     "Questo plugin non ha parametri di setup!",
     "Deze plugin heeft geen instelparameters",