===================================================================
RCS file: ./PLUGINS/src/dvbhddevice/RCS/hdffosd.c
retrieving revision 3.0
diff -u -b -r3.0 ./PLUGINS/src/dvbhddevice/hdffosd.c
--- ./PLUGINS/src/dvbhddevice/hdffosd.c	2013/03/02 17:58:21	3.0
+++ ./PLUGINS/src/dvbhddevice/hdffosd.c	2014/02/08 12:46:14
@@ -42,7 +42,6 @@
     tFont mFonts[MAX_NUM_FONTS];
     uint32_t mBitmapPalette;
     uint32_t mBitmapColors[256];
-    uint32_t mBitmapNumColors;
 
     bool mSupportsUtf8Text;
 
@@ -555,7 +554,6 @@
     uint32_t mDisplay;
     uint32_t mBitmapPalette;
     uint32_t mBitmapColors[256];
-    uint32_t mBitmapNumColors;
 
 protected:
     virtual void SetActive(bool On);
===================================================================
RCS file: ./PLUGINS/src/pictures/RCS/player.c
retrieving revision 3.0
diff -u -b -r3.0 ./PLUGINS/src/pictures/player.c
--- ./PLUGINS/src/pictures/player.c	2012/04/28 11:58:15	3.0
+++ ./PLUGINS/src/pictures/player.c	2014/02/08 12:48:12
@@ -211,7 +211,7 @@
 
 eOSState cPictureControl::ProcessKey(eKeys Key)
 {
-  switch (Key) {
+  switch (int(Key)) {
     case kUp:
     case kPlay:   slideShowDelay.Set();
                   slideShow = true;
===================================================================
RCS file: ./RCS/ci.c
retrieving revision 3.10
diff -u -b -r3.10 ./ci.c
--- ./ci.c	2014/01/22 09:46:38	3.10
+++ ./ci.c	2014/02/08 12:25:55
@@ -864,7 +864,7 @@
 #pragma pack(1)
      struct tTime { uint16_t mjd; uint8_t h, m, s; short offset; };
 #pragma pack()
-     tTime T = { mjd : htons(MJD), h : DEC2BCD(tm_gmt.tm_hour), m : DEC2BCD(tm_gmt.tm_min), s : DEC2BCD(tm_gmt.tm_sec), offset : short(htons(tm_loc.tm_gmtoff / 60)) };
+     tTime T = { .mjd = htons(MJD), .h = DEC2BCD(tm_gmt.tm_hour), .m = DEC2BCD(tm_gmt.tm_min), .s = DEC2BCD(tm_gmt.tm_sec), .offset = short(htons(tm_loc.tm_gmtoff / 60)) };
      bool OldDumpTPDUDataTransfer = DumpTPDUDataTransfer;
      DumpTPDUDataTransfer &= DumpDateTime;
      if (DumpDateTime)
@@ -1004,7 +1004,7 @@
                  case DCC_SET_MMI_MODE:
                       if (l == 2 && *++d == MM_HIGH_LEVEL) {
                          struct tDisplayReply { uint8_t id; uint8_t mode; };
-                         tDisplayReply dr = { id : DRI_MMI_MODE_ACK, mode : MM_HIGH_LEVEL };
+                         tDisplayReply dr = { .id = DRI_MMI_MODE_ACK, .mode = MM_HIGH_LEVEL };
                          dbgprotocol("Slot %d: ==> Display Reply (%d)\n", Tc()->CamSlot()->SlotNumber(), SessionId());
                          SendData(AOT_DISPLAY_REPLY, 2, (uint8_t *)&dr);
                          }
===================================================================
RCS file: ./RCS/dvbspu.h
retrieving revision 3.0
diff -u -b -r3.0 ./dvbspu.h
--- ./dvbspu.h	2013/01/20 10:15:47	3.0
+++ ./dvbspu.h	2014/02/08 12:27:34
@@ -101,7 +101,6 @@
     uint8_t *spu;
     uint32_t spupts;
     bool clean;
-    bool ready;
     bool restricted_osd;
 
     enum spFlag { spNONE, spHIDE, spSHOW, spMENU };
===================================================================
RCS file: ./RCS/dvbsubtitle.c
retrieving revision 3.4
diff -u -b -r3.4 ./dvbsubtitle.c
--- ./dvbsubtitle.c	2013/09/07 10:39:46	3.4
+++ ./dvbsubtitle.c	2014/02/08 12:29:13
@@ -34,7 +34,6 @@
 static bool DebugPages     = DebugVerbose || DebugNormal;
 static bool DebugRegions   = DebugVerbose || DebugNormal;
 static bool DebugObjects   = DebugVerbose || DebugNormal;
-static bool DebugBitmaps   = DebugVerbose || DebugNormal;
 static bool DebugConverter = DebugVerbose;
 static bool DebugSegments  = DebugVerbose;
 static bool DebugPixel     = DebugVerbose;
@@ -45,7 +44,6 @@
 #define dbgpages(a...)     if (DebugPages)     SD.WriteHtml(a)
 #define dbgregions(a...)   if (DebugRegions)   SD.WriteHtml(a)
 #define dbgobjects(a...)   if (DebugObjects)   SD.WriteHtml(a)
-#define dbgbitmaps(a...)   if (DebugBitmaps)   SD.WriteHtml(a)
 #define dbgconverter(a...) if (DebugConverter) SD.WriteHtml(a)
 #define dbgsegments(a...)  if (DebugSegments)  SD.WriteHtml(a)
 #define dbgpixel(a...)     if (DebugPixel)     SD.WriteHtml(a)
===================================================================
RCS file: ./RCS/eit.c
retrieving revision 3.3
diff -u -b -r3.3 ./eit.c
--- ./eit.c	2013/11/03 13:55:00	3.3
+++ ./eit.c	2014/02/08 12:33:01
@@ -220,7 +220,7 @@
             case SI::LinkageDescriptorTag: {
                  SI::LinkageDescriptor *ld = (SI::LinkageDescriptor *)d;
                  tChannelID linkID(Source, ld->getOriginalNetworkId(), ld->getTransportStreamId(), ld->getServiceId());
-                 if (ld->getLinkageType() == 0xB0) { // Premiere World
+                 if (uint(ld->getLinkageType()) == 0xB0) { // Premiere World
                     bool hit = StartTime <= Now && Now < StartTime + Duration;
                     if (hit) {
                        char linkName[ld->privateData.getLength() + 1];
===================================================================
RCS file: ./libsi/RCS/descriptor.h
retrieving revision 3.1
diff -u -b -r3.1 ./libsi/descriptor.h
--- ./libsi/descriptor.h	2013/10/30 10:16:18	3.1
+++ ./libsi/descriptor.h	2014/02/08 12:44:17
@@ -489,8 +489,6 @@
    StructureLoop<Language> languageLoop;
 protected:
    virtual void Parse();
-private:
-   const descr_iso_639_language *s;
 };
 
 class PDCDescriptor : public Descriptor {
===================================================================
RCS file: ./RCS/menu.c
retrieving revision 3.18
diff -u -b -r3.18 ./menu.c
--- ./menu.c	2014/01/30 09:04:06	3.18
+++ ./menu.c	2014/02/08 12:36:12
@@ -983,7 +983,7 @@
                        if (!*data.file)
                           strcpy(data.file, data.Channel()->ShortName(true));
                        if (timer) {
-                          if (memcmp(timer, &data, sizeof(data)) != 0)
+                          if (memcmp((void *)timer, &data, sizeof(data)) != 0)
                              *timer = data;
                           if (addIfConfirmed)
                              Timers.Add(timer);
===================================================================
RCS file: ./RCS/remux.h
retrieving revision 3.2
diff -u -b -r3.2 ./remux.h
--- ./remux.h	2014/01/28 11:06:37	3.2
+++ ./remux.h	2014/02/08 12:41:50
@@ -483,7 +483,6 @@
   bool independentFrame;
   uint32_t ptsValues[MaxPtsValues]; // 32 bit is enough - we only need the delta
   int numPtsValues;
-  int numFrames;
   int numIFrames;
   bool isVideo;
   double framesPerSecond;